/***
*	Dict.prg
* ⨫    祢묨 ᫮.
* Copyright (c) 1991 Nantucket Corp.   ࠢ ࠭.
*
*
* ᯮ ᨢ, ᮤঠ騩 ᯨ᮪ ᫮ ⮢ - .
*    ।⠢ ᮡ ᨢ, 騩  祢
* ᨬ쭮 祭  祭  ⨯.    
*   ᮮ⢥騥  祭, ⠪   祭  㦥
*  祩.
*
*
*	DictNew()  <--	<aDictionary>
*
*     頥 ⮩ ᫮.
*
*
*	DictAt( <aDictionary>, <cKey> )  <--  <xValue>
*
*   頥 祭, ᮮ⢥饥 <cKey>  ᫮,
*   ᫨ <cKey>   ᫮,  頥 NIL
*
*
*	DictPut( <aDictionary>, <cKey>, <xValue> )	<--  <xValue>
*
*   祭 <cKey>  ᫮ <aDictionary> ⠢  ᮮ⢥⢨ <xValue>.
*   頥 <xValue>.
*
*
*	DictPutPair( <aDictionary>, <aPair> )  <-- <aPair>
*
*    <aPair>  <aDictionary>. 頥 <aPair>.
*   <aPair>-  /祭: { <cKey>, <xValue> }.
*
*
*	DictRemove( <aDictionary>, <cKey> )  <-- <aDictionary>
*
*     /祭  <cKey>.
*   頥 <aDictionary>.
*
*
*	DictEval( <aDictionary>, <bBlock> )  <-- <aDictionary>
*
*    <bBlock>    <cKey>/<xValue>  ᫮.
*    ।      { <cKey>, <xValue> }
*   (   ।  䠩 "dict.ch").
*   頥 <aDictionary>.
*
*
* 砭:
*   ஢  ﬨ /n/w/a/m
*
*   祢 祭   ⨯ 'C',   訥
*   㪢 ࠧ.
*
*    ᫮ ᯮ   ,  室
*    ᯨ᮪ 祭,  ⥫쭮 ᯮ짮  .
*      ᫮ ᭮  ᨢ,   뢠
*   㤠  ६   ᨢ (ਬ ࠭
*   ᮢ ୮ "cargo").   祭 讬
*   ⢥ 祭  ।⥫  ᯮ짮
*   ஢  .
*
*/
/***********
* 䨪 ந  ""  ५ -  1991 .
*     祭 Nantucket Corp.
* ⥫.: (095) 289-43-00, (095) 289-44-77, (095) 289-44-83
* 䠪: (095) 289-34-69
************/


#include "dict.ch"


// 堭 ஢
#define KEY_HASH(key)		( Bin2W(key) + Bin2W( SubStr(Trim(key), -2) ) )
#define HASH_VAL(key, size) ( ( KEY_HASH(key) % size ) + 1 )

#define DEFAULT_HASH_SIZE		31
#define MAX_ARRAY_LEN			4096



/***
*	DictNew()
*/

FUNCTION DictNew()

	LOCAL i
	LOCAL dict

	dict := Array(DEFAULT_HASH_SIZE)

	FOR i := 1 to DEFAULT_HASH_SIZE
		dict[i] := {}
	NEXT

	RETURN ( dict )



/***
*	DictAt()
* 頥 祭  㪠 .
*/

FUNCTION DictAt( dict, key )

	LOCAL bucket
	LOCAL i

	bucket := dict[ HASH_VAL(key, Len(dict)) ]
	i := AScan( bucket, { |assoc| assoc[ DI_KEY ] == key } )

	if ( i == 0 )
		RETURN (NIL)
	end

	RETURN ( bucket[i][DI_VAL] )



/***
*	DictPut()
*    祭  㪠 .
* 頥  祭.
*/

FUNCTION DictPut( dict, key, val )

	DictPutPair( dict, {key, val} )

	RETURN (val)



/***
*	DictPutPair()
*   頥  /祭  㪠 .
* 頥  .
*/

FUNCTION DictPutPair( dict, pair )

	LOCAL bucket
	LOCAL key
	LOCAL i

	key := pair[ DI_KEY ]

	bucket := dict[ HASH_VAL(key, Len(dict)) ]
	i := AScan( bucket, { |assoc| assoc[ DI_KEY ] == key } )

	if ( i == 0 )
		AAdd( bucket, pair )
		i := Len( bucket )
	else
		bucket[i] := pair
	end

	if ( i > 3 .and. Len(dict) < MAX_ARRAY_LEN )
    // bucket 让, 㢥 ᫮
		DictResize(dict)
	end

	RETURN ( pair )



/***
*	DictRemove()
*   /祭  㪠 .
* 頥 뫪  ᫮.
*/

FUNCTION DictRemove( dict, key )

	LOCAL bucket
	LOCAL i

	bucket := dict[ HASH_VAL(key, Len(dict)) ]
	i := AScan( bucket, { |assoc| assoc[ DI_KEY ] == key } )

	if ( i <> 0 )
		ADel( bucket, i )
		ASize( bucket, Len(bucket) - 1 )
    end

	RETURN ( dict )



/***
*	DictEval()
* 믮      ᫮,    ⢥
* 㬥 뫠 ⥪ 
* 頥 뫪  ᫮.
*/

FUNCTION DictEval( dict, block )

	AEval( dict, ;
		{ |bucket| AEval( bucket, { |assoc| Eval(block, assoc) } ) } )

	RETURN ( dict )



/***
*	DictResize()
*
* ࢨ᭠ 㭪. 稢 ⠡ ஢ ᫮.
*
* 砭:  ।, 㫨஢   אַ ஢
*  室 맮 ⮩ 㭪樨 室 ন.
*/

STATIC FUNCTION DictResize( dict )

	LOCAL old
	LOCAL size
	LOCAL i

  // ᮧ  ᫮
	old := Array( Len(dict) )
	ACopy( dict, old )

  //  稭 ᫮
	size := Min( Len(dict) * 4 - 1, MAX_ARRAY_LEN )
	ASize( dict, size )

	FOR i := 1 to size
		dict[i] := {}
	NEXT

  // ஢   ᫮
	AEval( old, ;
		{ |bucket| AEval( bucket, ;
			{ |assoc| DictPutPair( dict, assoc ) } ) } )

	RETURN ( dict )